#
# Conditional build:
%bcond_without	qt4		# build Qt4
%bcond_without	qt5		# build Qt5

# last commit to qtsingleapplication subdir in
# https://qt.gitorious.org/qt-solutions/qt-solutions/
%define	commit	ad9bc4600ce769a8b3ad10910803cd555811b70c
Summary:	Qt 4 library to start applications only once per user
Summary(pl.UTF-8):	Biblioteka Qt 4 do uruchamiania pojedynczej instancji aplikacji na użytkownika
Name:		QtSingleApplication
Version:	2.6.1
Release:	5
License:	GPL v3 or LGPL v2 with exceptions
Group:		Libraries
Source0:	https://github.com/qtproject/qt-solutions/archive/%{commit}/%{name}-%{commit}.tar.gz
# Source0-md5:	07f01898ad475c5cded2968d25bee85c
Source1:	qtsingleapplication.prf
Source2:	qtsinglecoreapplication.prf
Patch0:		qtsingleapplication-build.diff
Patch1:		qtlockedfile.patch
Patch2:		clementine.patch
Patch3:		version.patch
Patch4:		qtsingleapplication-install.patch
URL:		http://doc.qt.digia.com/solutions/4/qtsingleapplication/qtsingleapplication.html
BuildRequires:	glibc-misc
BuildRequires:	libstdc++-devel
%if %{with qt4}
BuildRequires:	QtGui-devel >= 4
BuildRequires:	QtLockedFile-devel
BuildRequires:	QtNetwork-devel >= 4
BuildRequires:	qt4-build >= 4
BuildRequires:	qt4-qmake >= 4
%endif
%if %{with qt5}
BuildRequires:	Qt5Core-devel >= 5.4
BuildRequires:	Qt5Gui-devel >= 5.4
BuildRequires:	Qt5LockedFile-devel
BuildRequires:	Qt5Network-devel >= 5.4
BuildRequires:	Qt5Widgets-devel >= 5.4
BuildRequires:	qt5-build >= 5.4
BuildRequires:	qt5-qmake >= 5.4
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		qt4dir	%{_datadir}/qt4
%define		qt5dir	%{_libdir}/qt5

%description
For some applications it is useful or even critical that they are
started only once by any user. Future attempts to start the
application should activate any already running instance, and possibly
perform requested actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a
running instance, and to send command strings to that instance.

For console (non-GUI) applications, the QtSingleCoreApplication
variant is provided, which avoids dependency on QtGui.

%description -l pl.UTF-8
Dla niektórych aplikacji przydatne, lub nawet krytyczne, jest to, aby
uruchamiane były tylko w jednej instancji na użytkownika. Kolejne
próby uruchomienia powinny aktywować już działającą instancję i
ewentualnie wyjonywać żądane akcje, np. załadowanie pliku w tej
instancji.

Klasa QtSingleApplication udostępnia interfejs do wykrywania
działającej instancji i wysyłania do niej łańcuchów poleceń.

Dla aplikacji konsolowych (bez GUI) udostępniony jest wariant
QtSingleCoreApplication, który nie ma zależności od QtGui.

%package devel
Summary:	Development files for QtSingleApplication
Summary(pl.UTF-8):	Pliki programistyczne biblioteki QtSingleApplication
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	QtCore-devel >= 4

%description devel
This package contains header files for developing applications that
use QtSingleApplication.

%description devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe do tworzenia aplikacji
wykorzystujących QtSingleApplication.

%package -n Qt5SingleApplication
Summary:	Qt 5 library to start applications only once per user
Summary(pl.UTF-8):	Biblioteka Qt 5 do uruchamiania pojedynczej instancji aplikacji na użytkownika
Group:		Libraries

%description -n Qt5SingleApplication
For some applications it is useful or even critical that they are
started only once by any user. Future attempts to start the
application should activate any already running instance, and possibly
perform requested actions, e.g. loading a file, in that instance.

The QtSingleApplication class provides an interface to detect a
running instance, and to send command strings to that instance.

For console (non-GUI) applications, the QtSingleCoreApplication
variant is provided, which avoids dependency on QtGui.

%description -n Qt5SingleApplication -l pl.UTF-8
Dla niektórych aplikacji przydatne, lub nawet krytyczne, jest to, aby
uruchamiane były tylko w jednej instancji na użytkownika. Kolejne
próby uruchomienia powinny aktywować już działającą instancję i
ewentualnie wyjonywać żądane akcje, np. załadowanie pliku w tej
instancji.

Klasa QtSingleApplication udostępnia interfejs do wykrywania
działającej instancji i wysyłania do niej łańcuchów poleceń.

Dla aplikacji konsolowych (bez GUI) udostępniony jest wariant
QtSingleCoreApplication, który nie ma zależności od QtGui.

%package -n Qt5SingleApplication-devel
Summary:	Development files for Qt5SingleApplication library
Summary(pl.UTF-8):	Pliki programistyczne biblioteki Qt5SingleApplication
Group:		Development/Libraries
Requires:	Qt5SingleApplication = %{version}-%{release}
Requires:	Qt5Core-devel >= 5

%description -n Qt5SingleApplication-devel
This package contains header files for developing applications that
use Qt5SingleApplication.

%description -n Qt5SingleApplication-devel -l pl.UTF-8
Ten pakiet zawiera pliki nagłówkowe do tworzenia aplikacji
wykorzystujących Qt5SingleApplication.

%prep
%setup -qc
%{__mv} qt-solutions-* .qtsolutions
%{__mv} .qtsolutions/qtsingleapplication/* .
%patch0 -p0
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1

# We already disabled bundling this external library.
# But just to make sure:
%{__rm} src/{QtLocked,qtlocked}*

%build
# Does not use GNU configure
./configure -library

%if %{with qt4}
install -d build-qt4
cd build-qt4
qmake-qt4 ../qtsingleapplication.pro \
	QMAKE_CXX="%{__cxx}" \
	QMAKE_CXXFLAGS_RELEASE="%{rpmcxxflags}" \
	QMAKE_LFLAGS_RELEASE="%{rpmldflags}" \
	INSTALL_LIBDIR=%{_libdir}
%{__make}

# ensure the it links to right version of LockedFile
for l in SingleApplication SingleCoreApplication; do
	f=libQtSolutions_$l-2.6.so
	ldd ../lib/$f | grep libQtSolutions_LockedFile
done
cd ..
%endif

%if %{with qt5}
install -d build-qt5
cd build-qt5
qmake-qt5 ../qtsingleapplication.pro \
	QMAKE_CXX="%{__cxx}" \
	QMAKE_CXXFLAGS_RELEASE="%{rpmcxxflags}" \
	QMAKE_LFLAGS_RELEASE="%{rpmldflags}" \
	INSTALL_LIBDIR=%{_libdir}
%{__make}

# ensure the it links to right version of LockedFile
for l in SingleApplication SingleCoreApplication; do
	f=libQt5Solutions_$l-2.6.so
	ldd ../lib/$f | grep libQt5Solutions_LockedFile
done
cd ..
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with qt4}
%{__make} -C build-qt4 install \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_includedir}/qt4/QtSolutions,%{qt4dir}/mkspecs/features}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.so.1.0
cp -p src/qtsingle*application.h src/QtSingle*Application $RPM_BUILD_ROOT%{_includedir}/qt4/QtSolutions
cp -p %{SOURCE1} %{SOURCE2} $RPM_BUILD_ROOT%{qt4dir}/mkspecs/features
%endif

%if %{with qt5}
%{__make} -C build-qt5 install \
	INSTALL_ROOT=$RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_includedir}/qt5/QtSolutions,%{qt5dir}/mkspecs/features}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.so.1.0
cp -p src/qtsingle*application.h src/QtSingle*Application $RPM_BUILD_ROOT%{_includedir}/qt5/QtSolutions
%{__sed} -e 's/-lQtSolutions/-lQt5Solutions/g' %{SOURCE1} > $RPM_BUILD_ROOT%{qt5dir}/mkspecs/features/qtsingleapplication.prf
%{__sed} -e 's/-lQtSolutions/-lQt5Solutions/g' %{SOURCE2} > $RPM_BUILD_ROOT%{qt5dir}/mkspecs/features/qtsinglecoreapplication.prf
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post	-n Qt5SingleApplication -p /sbin/ldconfig
%postun	-n Qt5SingleApplication -p /sbin/ldconfig

%if %{with qt4}
%files
%defattr(644,root,root,755)
%doc README.TXT
%attr(755,root,root) %{_libdir}/libQtSolutions_SingleApplication-2.6.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQtSolutions_SingleApplication-2.6.so.1
%attr(755,root,root) %{_libdir}/libQtSolutions_SingleCoreApplication-2.6.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQtSolutions_SingleCoreApplication-2.6.so.1

%files devel
%defattr(644,root,root,755)
%doc doc examples
%attr(755,root,root) %{_libdir}/libQtSolutions_SingleApplication-2.6.so
%attr(755,root,root) %{_libdir}/libQtSolutions_SingleCoreApplication-2.6.so
%{_includedir}/qt4/QtSolutions/QtSingleApplication
%{_includedir}/qt4/QtSolutions/QtSingleCoreApplication
%{_includedir}/qt4/QtSolutions/qtsingleapplication.h
%{_includedir}/qt4/QtSolutions/qtsinglecoreapplication.h
%{qt4dir}/mkspecs/features/qtsingleapplication.prf
%{qt4dir}/mkspecs/features/qtsinglecoreapplication.prf
%endif

%if %{with qt5}
%files -n Qt5SingleApplication
%defattr(644,root,root,755)
%doc README.TXT
%attr(755,root,root) %{_libdir}/libQt5Solutions_SingleApplication-2.6.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQt5Solutions_SingleApplication-2.6.so.1
%attr(755,root,root) %{_libdir}/libQt5Solutions_SingleCoreApplication-2.6.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libQt5Solutions_SingleCoreApplication-2.6.so.1

%files -n Qt5SingleApplication-devel
%defattr(644,root,root,755)
%doc doc examples
%attr(755,root,root) %{_libdir}/libQt5Solutions_SingleApplication-2.6.so
%attr(755,root,root) %{_libdir}/libQt5Solutions_SingleCoreApplication-2.6.so
%{_includedir}/qt5/QtSolutions/QtSingleApplication
%{_includedir}/qt5/QtSolutions/QtSingleCoreApplication
%{_includedir}/qt5/QtSolutions/qtsingleapplication.h
%{_includedir}/qt5/QtSolutions/qtsinglecoreapplication.h
%{qt5dir}/mkspecs/features/qtsingleapplication.prf
%{qt5dir}/mkspecs/features/qtsinglecoreapplication.prf
%endif
%changelog
* Mon Dec 31 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/QtSingleApplication.git;a=log;h=master

* Mon Dec 31 2018 Jakub Bogusz <qboosh@pld-linux.org> 5174eaa
- pl
- added install patch, use make install and single source dir with split build dirs
- release 5

* Sun May 28 2017 Jan Rękorajski <baggins@pld-linux.org> c6a37da
- fix specs for qt5
- rel 4

* Wed Apr 13 2016 Elan Ruusamäe <glen@delfi.ee> 1bb0d70
- hack: link qt5 version qith qt5 libs

* Wed Apr 13 2016 Elan Ruusamäe <glen@delfi.ee> db4dc12
- copy only library

* Tue Apr 12 2016 Elan Ruusamäe <glen@delfi.ee> 8cc7702
- ensure the it links to right version of LockedFile

* Tue Apr 12 2016 Elan Ruusamäe <glen@delfi.ee> e3b3d3a
- update to ad9bc4600ce769a8b3ad10910803cd555811b70c

* Tue Apr 12 2016 Elan Ruusamäe <glen@delfi.ee> c64ddd1
- typos

* Wed Mar 11 2015 Jan Rękorajski <baggins@pld-linux.org> c54a9d6
- new qmake-qt5 can do library name change byt itself
- rel 2

* Tue Feb 24 2015 Elan Ruusamäe <glen@delfi.ee> 2cb2917
- drop qt*-build, and qt*-qmake from -devel deps

* Mon Feb 23 2015 Elan Ruusamäe <glen@delfi.ee> 98529ad
- cleanup deps, fix build

* Mon Feb 23 2015 Elan Ruusamäe <glen@delfi.ee> 97b6f03
- add qt5 packages

* Sun Feb 22 2015 Elan Ruusamäe <glen@delfi.ee> 3e0bb37
- update clementine patch against current git (841982ceec9d30a7ab7324979a0fd5c9c36fd121)

* Sun Feb 22 2015 Elan Ruusamäe <glen@delfi.ee> d71b6f8
- update clementine patch, now it's source compatible with upstream

* Sun Feb 22 2015 Elan Ruusamäe <glen@delfi.ee> dfdbbb1
- cleanups

* Sun Feb 22 2015 Elan Ruusamäe <glen@delfi.ee> 5c92ed7
- up to 2.6.1

* Sun Apr 03 2011 Elan Ruusamäe <glen@pld-linux.org> 7023061
- install to qt4 subdir for qbittorrent to find; rel 5

* Wed Sep 22 2010 Elan Ruusamäe <glen@pld-linux.org> 1c128bd
- from fc

* Wed Sep 22 2010 Elan Ruusamäe <glen@pld-linux.org> 099d1b5
- update patches from fc, SingleCoreApplication built now as well

* Mon Sep 06 2010 Elan Ruusamäe <glen@pld-linux.org> b639dac
- add patch from clementine; rel 3

* Mon Sep 06 2010 Elan Ruusamäe <glen@pld-linux.org> 2d2fc45
- adjust against qtsingleapplication-dont-bundle-external-libs.patch being already applied

